//+------------------------------------------------------------------+
//|                                                  TradeCopier.mq4 |
//|                                    Copyright  2008, fxtrader625 |
//|                                  http://www.forexampletrades.com |
//|                            Donation: paypal@forexampletrades.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, fxtrader625"
#property link      "http://www.forexampletrades.com"
#property library

#import "TradeSwitch.dll"
int SendSignal(string Name, string Value);
#import

//+------------------------------------------------------------------+
//| Library functions                                                |
//+------------------------------------------------------------------+
void CopyTrade(int ticket, bool reverse)
{
   if (OrderSelect(ticket, SELECT_BY_TICKET))
   {
      int cmd = OrderType();
      int spread = MarketInfo(OrderSymbol(), MODE_SPREAD);
      double point = MarketInfo(OrderSymbol(), MODE_POINT);
      double volume = OrderLots();
      
      // Variables for normal trades
      double price = OrderOpenPrice();
      double stoploss = OrderStopLoss();
      double takeprofit = OrderTakeProfit();
      
      // Variables for reversed trades
      double priceplusspread = price + point * spread;
      double priceminusspread = price - point * spread;
      double stoplossplusspread = stoploss + point * spread;
      double stoplossminusspread = stoploss - point * spread;
      double takeprofitplusspread = takeprofit + point * spread;
      double takeprofitminusspread = takeprofit - point * spread;
      
      switch (cmd)
      {
      case OP_BUY:
         // OrderSend,cmd,volume,stoploss,takeprofit,ticket
         if (!reverse)
         {
            SendSignal(OrderSymbol(), "OrderSend,OP_BUY,"
               + volume + ","
               + "0,"
               + stoploss + ","
               + takeprofit + ","
               + ticket);
         }
         else
         {
            SendSignal(OrderSymbol(), "OrderSend,OP_SELL,"
               + volume + ","
               + "0,"
               + takeprofitplusspread + ","
               + stoplossplusspread + ","
               + ticket);
         }
         break;
      case OP_SELL:
         // OrderSend,cmd,volume,stoploss,takeprofit,ticket
         if (!reverse)
         {
            SendSignal(OrderSymbol(), "OrderSend,OP_SELL,"
               + volume + ","
               + "0,"
               + stoploss + ","
               + takeprofit + ","
               + ticket);
         }
         else
         {
            SendSignal(OrderSymbol(), "OrderSend,OP_BUY,"
               + volume + ","
               + "0,"
               + takeprofitminusspread + ","
               + stoplossminusspread + ","
               + ticket);
         }
         break;
      case OP_BUYSTOP:
         if (!reverse)
         {
            SendSignal(OrderSymbol(), "OrderSend,OP_BUYSTOP,"
               + volume + ","
               + price + ","
               + stoploss + ","
               + takeprofit + ","
               + ticket);
         }
         else
         {
            SendSignal(OrderSymbol(), "OrderSend,OP_SELLLIMIT,"
               + volume + ","
               + priceminusspread + ","
               + takeprofitplusspread + ","
               + stoplossplusspread + ","
               + ticket);
         }
         break;
      case OP_SELLLIMIT:
         if (!reverse)
         {
            SendSignal(OrderSymbol(), "OrderSend,OP_SELLLIMIT,"
               + volume + ","
               + price + ","
               + stoploss + ","
               + takeprofit + ","
               + ticket);
         }
         else
         {
            SendSignal(OrderSymbol(), "OrderSend,OP_BUYSTOP,"
               + volume + ","
               + priceplusspread + ","
               + takeprofitminusspread + ","
               + stoplossminusspread + ","
               + ticket);
         }
         break;
      case OP_SELLSTOP:
         if (!reverse)
         {
            SendSignal(OrderSymbol(), "OrderSend,OP_SELLSTOP,"
               + volume + ","
               + price + ","
               + stoploss + ","
               + takeprofit + ","
               + ticket);
         }
         else
         {
            SendSignal(OrderSymbol(), "OrderSend,OP_BUYLIMIT,"
               + volume + ","
               + priceplusspread + ","
               + takeprofitminusspread + ","
               + stoplossminusspread + ","
               + ticket);
         }
         break;
      case OP_BUYLIMIT:
         if (!reverse)
         {
            SendSignal(OrderSymbol(), "OrderSend,OP_BUYLIMIT,"
               + volume + ","
               + price + ","
               + stoploss + ","
               + takeprofit + ","
               + ticket);
         }
         else
         {
            SendSignal(OrderSymbol(), "OrderSend,OP_SELLSTOP,"
               + volume + ","
               + priceminusspread + ","
               + takeprofitplusspread + ","
               + stoplossplusspread + ","
               + ticket);
         }
         break;
      }
   }
}

void UpdateTrade(int ticket, bool reverse)
{
   if (OrderSelect(ticket, SELECT_BY_TICKET))
   {
      int cmd = OrderType();
      int spread = MarketInfo(OrderSymbol(), MODE_SPREAD);
      double point = MarketInfo(OrderSymbol(), MODE_POINT);
      
      // Variables for normal trades
      double price = OrderOpenPrice();
      double stoploss = OrderStopLoss();
      double takeprofit = OrderTakeProfit();
      
      // Variables for reversed trades
      double priceplusspread = price + point * spread;
      double priceminusspread = price - point * spread;
      double stoplossplusspread = stoploss + point * spread;
      double stoplossminusspread = stoploss - point * spread;
      double takeprofitplusspread = takeprofit + point * spread;
      double takeprofitminusspread = takeprofit - point * spread;
      
      switch (cmd)
      {
      case OP_BUY:
         // OrderModify,ticket,price,stoploss,takeprofit
         if (!reverse)
         {
            SendSignal(OrderSymbol(), "OrderModify,"
               + ticket + ","
               + "0,"
               + stoploss + ","
               + takeprofit);
         }
         else
         {
            SendSignal(OrderSymbol(), "OrderModify,"
               + ticket + ","
               + "0,"
               + takeprofitplusspread + ","
               + stoplossplusspread);
         }
         break;
      case OP_SELL:
         // OrderModify,ticket,price,stoploss,takeprofit
         if (!reverse)
         {
            SendSignal(OrderSymbol(), "OrderModify,"
               + ticket + ","
               + "0,"
               + stoploss + ","
               + takeprofit);
         }
         else
         {
            SendSignal(OrderSymbol(), "OrderModify,"
               + ticket + ","
               + "0,"
               + takeprofitminusspread + ","
               + stoplossminusspread);
         }
         break;
      case OP_BUYSTOP:
      case OP_BUYLIMIT:
         if (!reverse)
         {
            SendSignal(OrderSymbol(), "OrderModify,"
               + ticket + ","
               + price + ","
               + stoploss + ","
               + takeprofit);
         }
         else
         {
            SendSignal(OrderSymbol(), "OrderModify,"
               + ticket + ","
               + priceminusspread + ","
               + takeprofitplusspread + ","
               + stoplossplusspread);
         }
         break;
      case OP_SELLSTOP:
      case OP_SELLLIMIT:
         if (!reverse)
         {
            SendSignal(OrderSymbol(), "OrderModify,"
               + ticket + ","
               + price + ","
               + stoploss + ","
               + takeprofit);
         }
         else
         {
            SendSignal(OrderSymbol(), "OrderModify,"
               + ticket + ","
               + priceplusspread + ","
               + takeprofitminusspread + ","
               + stoplossminusspread);
         }
         break;
      }
   }
}

void CloseTrade(int ticket, double volume = -1)
{
   SendSignal(Symbol(), "OrderClose," + ticket + "," + volume);
}

void DeleteTrade(int ticket)
{
   SendSignal(Symbol(), "OrderDelete," + ticket);
}

void CopyTradeToAccount(int account, int ticket, bool reverse)
{
   if (OrderSelect(ticket, SELECT_BY_TICKET))
   {
      // Declare local variables
      string accString = DoubleToStr(account,0);
      string symbol = OrderSymbol();
      double volume = OrderLots();
      int spread = MarketInfo(OrderSymbol(), MODE_SPREAD);
      double point = MarketInfo(OrderSymbol(), MODE_POINT);
      
      // Variables for normal trades
      double price = OrderOpenPrice();
      double stoploss = OrderStopLoss();
      double takeprofit = OrderTakeProfit();
      
      // Variables for reversed trades
      double priceplusspread = price + point * spread;
      double priceminusspread = price - point * spread;
      double stoplossplusspread = stoploss + point * spread;
      double stoplossminusspread = stoploss - point * spread;
      double takeprofitplusspread = takeprofit + point * spread;
      double takeprofitminusspread = takeprofit - point * spread;

      // Case structure
      switch (OrderType())
      {
      case OP_BUY:
         // OrderSend,symbol,cmd,volume,price,stoploss,takeprofit,ticket
         if (!reverse)
         {
            SendSignal(accString, "OrderSend,"
               + symbol + ","
               + "OP_BUY,"
               + volume + ","
               + "0,"
               + stoploss + ","
               + takeprofit + ","
               + ticket);
         }
         else
         {
            SendSignal(accString, "OrderSend,"
               + symbol + ","
               + "OP_SELL,"
               + volume + ","
               + "0,"
               + takeprofitplusspread + ","
               + stoplossplusspread + ","
               + ticket);
         }
         break;
      case OP_SELL:
         // OrderSend,symbol,cmd,volume,price,stoploss,takeprofit,ticket
         if (!reverse)
         {
            SendSignal(accString, "OrderSend,"
               + symbol + ","
               + "OP_SELL,"
               + volume + ","
               + "0,"
               + stoploss + ","
               + takeprofit + ","
               + ticket);
         }
         else
         {
            SendSignal(accString, "OrderSend,"
               + symbol + ","
               + "OP_BUY,"
               + volume + ","
               + "0,"
               + takeprofitminusspread + ","
               + stoplossminusspread + ","
               + ticket);
         }
         break;
      case OP_BUYSTOP:
         if (!reverse)
         {
            SendSignal(accString, "OrderSend,"
               + symbol + ","
               + "OP_BUYSTOP,"
               + volume + ","
               + price + ","
               + stoploss + ","
               + takeprofit + ","
               + ticket);
         }
         else
         {
            SendSignal(accString, "OrderSend,"
               + symbol + ","
               + "OP_SELLLIMIT,"
               + volume + ","
               + priceminusspread + ","
               + takeprofitplusspread + ","
               + stoplossplusspread + ","
               + ticket);
         }
         break;
      case OP_SELLLIMIT:
         if (!reverse)
         {
            SendSignal(accString, "OrderSend,"
               + symbol + ","
               + "OP_SELLLIMIT,"
               + volume + ","
               + price + ","
               + stoploss + ","
               + takeprofit + ","
               + ticket);
         }
         else
         {
            SendSignal(accString, "OrderSend,"
               + symbol + ","
               + "OP_BUYSTOP,"
               + volume + ","
               + priceplusspread + ","
               + takeprofitminusspread + ","
               + stoplossminusspread + ","
               + ticket);
         }
         break;
      case OP_SELLSTOP:
         if (!reverse)
         {
            SendSignal(accString, "OrderSend,"
               + symbol + ","
               + "OP_SELLSTOP,"
               + volume + ","
               + price + ","
               + stoploss + ","
               + takeprofit + ","
               + ticket);
         }
         else
         {
            SendSignal(accString, "OrderSend,"
               + symbol + ","
               + "OP_BUYLIMIT,"
               + volume + ","
               + priceplusspread + ","
               + takeprofitminusspread + ","
               + stoplossminusspread + ","
               + ticket);
         }
         break;
      case OP_BUYLIMIT:
         if (!reverse)
         {
            SendSignal(accString, "OrderSend,"
               + symbol + ","
               + "OP_BUYLIMIT,"
               + volume + ","
               + price + ","
               + stoploss + ","
               + takeprofit + ","
               + ticket);
         }
         else
         {
            SendSignal(accString, "OrderSend,"
               + symbol + ","
               + "OP_SELLSTOP,"
               + volume + ","
               + priceminusspread + ","
               + takeprofitplusspread + ","
               + stoplossplusspread + ","
               + ticket);
         }
         break;
      }
   }
}

